Unit SF57R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF14_p;

procedure SF57R(K :Integer; NFORM :Integer; LFORM :Integer;
                N1 :Integer; var P :Real; var Q :Real;
                var IERR :Integer);

implementation

procedure SF57R(K :Integer; NFORM :Integer; LFORM :Integer;
                N1 :Integer; var P :Real; var Q :Real;
                var IERR :Integer);
var
M,N,L,ND,NND,NXD,IFLAG,K0,MM1,MM,ICNT :Integer;
SP,B,ANND,ANXD,AA,BB,AJ,A1,B1,U,A :Real;
const
EPS :Real = 1.0E-36;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
N := LFORM;
L := NFORM;
ND := N1;
if ( (K >= 0) ) and ( (K <= N) ) 
 then goto _1;
IERR := 66;
goto _14;
_1:
if ( (N >= 1) ) and ( (N <= L) ) 
 then goto _2;
IERR := 67;
goto _14;
_2:
if ( (ND >= 0) ) and ( (ND <= L) ) 
 then goto _3;
IERR := 68;
goto _14;
_3:
IERR := 0;
P := 0.E0;
SP := 0.E0;
if ( K > ND ) 
 then goto _12;
if ( (N-K) > (L-ND) ) 
 then goto _13;
P := 1.E0;
NND := Min0(N,ND);
NXD := Max0(N,ND);
B := L;
ANND := NND;
ANXD := NXD;
if ( (K*(L+2)) > ((ND+1)*(N+1)) ) 
 then goto _4;
IFLAG := 0;
AA := ANXD-ANND;
BB := B-ANXD-ANND;
K0 := N+ND-L;
if ( K0 < 0 ) 
 then K0 := 0;
AJ := K0;
A1 := ANND-AJ;
B1 := AJ+1.E0;
MM1 := K-K0;
A := B-ANXD+AJ;
MM := NND-K0;
goto _5;
_4:
IFLAG := 1;
AA := B-ANXD-ANND;
BB := ANXD-ANND;
A1 := ANND;
B1 := 1.E0;
MM1 := NND-K;
MM := L-NXD;
A := B-ANND;
if ( NND >= MM ) 
 then goto _5;
MM := NND;
A := ANXD;
_5:
ICNT := 0;
if ( MM = 0 ) 
 then goto _8;
for M:=1 to MM do
 begin
  U := A/B;
  if ( U >= EPS/P ) 
   then goto _6;
  P := P/EPS;
  ICNT := ICNT+1;
_6:
  P := P*U;
  A := A-1.E0;
  B := B-1.E0;
_7:
 end;
_8:
if ( MM1 = 0 ) 
 then goto _11;
for M:=1 to MM1 do
 begin
  if ( ICNT = 0 ) 
   then SP := SP+P;
  U := A1*(A1+AA)/(B1*(B1+BB));
  P := U*P;
  if ( P < 1.E0 ) 
   then goto _9;
  P := P*EPS;
  ICNT := ICNT-1;
_9:
  A1 := A1-1.E0;
  B1 := B1+1.E0;
_10:
 end;
_11:
if ( ICNT <> 0 ) 
 then P := 0.E0;
if ( IFLAG <> 0 ) 
 then goto _12;
SP := SP+P;
goto _13;
_12:
SP := 1.E0-SP;
_13:
Q := SP;
goto _15;
_14:
UTSF14(IERR,57);
_15:
end;

end.
